struct PLAYER
 {
  bool boom;
  int x,y;
  int actfr;
  int invis;
  BITMAP *frame[9];
 } player,player2;

struct BULLET
 {
  int x,y;
  int v;
  bool fired;
  bool boom;
  int actfr;
  int hits;
  BITMAP *frame[20];
 } bullet[4],bullet2[4];

struct ALIEN
 {
  bool dead;
  bool boom;
  bool hitted;
  int x,y;
  int actfr;
  int hits;
  BITMAP* frame[9];
 } alien[8][5];

struct BOMB
 {
  int x,y;
  bool fired;
  int actfr;
  BITMAP *frame[9];
 } bomb[10];

struct BOSS
 {
  bool dead;
  bool boom;
  bool hitted;
  fixed aux;
  int state;
  int attack;
  int x,y;
  int dx,dy;
  int sp;
  int actfr;
  double ang;
  double angsp;
  int hits;
  BITMAP* frame[9];
 } boss,boss1,boss2,boss3,boss4;

struct BOSS_BOMB
 {
  int x,y;
  int sp;
  bool fired;
  bool boom;
  int actfr;
  BITMAP *frame[9];
 } boss_bomb[12];

struct SHIP
 {
  bool dead;
  bool boom;
  bool hitted;
  int x,y;
  int actfr;
  int hits;
  int stato;
  int aux;
  BITMAP* frame[11];
 } ship;

struct SHIP_BOMB
 {
  int x,y;
  bool fired;
  bool boom;
  int actfr;
  BITMAP *frame[9];
 } ship_bomb;

struct ANIM
 {
  int actfr;
  int maxfr;
  BITMAP* frame[9];
 } anim[5];

struct INTRO
 {
 	int x,y;
  int actfr;
  int maxfr;
  int aux;
  BITMAP* frame[9];
 } intro[6];

struct BOARD
 {
  BITMAP *frame;
 } board1,board2;

struct BONUS
 {
  bool active;
  bool money;
  int x,y;
  int sec;
  int value;
  int actfr;
  BITMAP *frame[15];
 } bonus;

struct SCORETB
 {
  char name[18];
  int score;
  int level;
 } scoretb[5];

struct EXPLOSION
 {
  bool boom;
  int x,y;
  int actfr;
  BITMAP* frame[7];
 } explosion[7];

BITMAP *buffer;
BITMAP *bg,*sky;
BITMAP *shop[7];
PALETTE pal;

MIDI *bgsound;
SAMPLE *pl_fx[9];
SAMPLE *al_fx[9];

FILE *fd;

clock_t msss,mss,mss2,ms,msf,msff;
bool synss,syns,syns2,syn,synf,synff;
bool gameover,gameover1,gameover2;

int level,lives,score,hiscore,money,power,weapon,speed;
int lives2,score2,money2,power2,weapon2,speed2;
int LIVES,MONEY,POWER,WEAPON,MODE,SKILL,NPLAYERS;
bool CHEAT,CHEAT2;
int pl_n,pl_n2;

int bgcol,txcol,swcol;

int animf;

int al_x,al_y;
int al_v,al_dx,al_dx2,al_dxm,al_dy,al_dy2,al_dym,al_dytot;
int al_down,al_fr;
int bo_d,bo_m,bo_v;
int al_count;
int al_hits;

bool bosshere;
int act_boss;
int exp_n;
bool fl_des,fl_exp;

bool push,push2;
int ibul,mbul;
int ibul2,mbul2;
int bul_pw,bul_pw2;
int bul_speed,bul_speed2;
int bul_aux,bul_aux2;

void Aliens();
void AliensBomb();
void AliensBombInit();
void AliensDown();
void AliensDraw();
void AliensShadow();
void AliensInit(int);
void AliensMove();
void Animation();
void Board();
void Bonus();
void Boss();
bool Boss1();
bool Boss2();
bool Boss3();
bool Boss4();
bool Boss5();
bool BossExplode();
void BossInit(int);
void Bullet();
void Bullet2();
void CheckExtra();
void Collision();
void Collision2();
void Credits();
void End();
void Exit();
void GameControl();
void GameInit();
void GameOver();
bool hitTest(BITMAP *,BITMAP *,int,int,int,int);
bool hitTestFast(BITMAP *,BITMAP *,int,int,int,int);
int Init();
int InitPlay();
void Intro();
void LevelInit();
void LoadData(int);
void Paint();
void Player();
void Player2();
void Player2Enter();
void PlayerInit();
void Playerrestart();
void Playerrestart2();
int Random(int);
void RestoreBullet(int);
void RestoreBullet2(int);
void ScoreBoard(int);
void ScoreBoardInit();
void ScoreBoardInput(int);
void ScoreBoardShow(int);
void ScoreBoardWrite();
void Ship();
void ShipBomb();
void ShipCollision();
void ShipDraw();
void ShipInit(int);
void Shop();
void Shop2();
void Sync();
void Title();
void ToScreen(BITMAP *);
void wait(int);

// Funzioni a basso livello
int Init()
 {
  allegro_init();
  install_keyboard(); 
  install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,0);
  if(WIN)
   {
    if(set_gfx_mode(GFX_AUTODETECT_WINDOWED,SCR_W,SCR_H,0,0)!=0)
     {
      allegro_exit();
      printf("Error setting graphics mode (WINDOWED):\n -> %s\n\n", allegro_error);
      return 1;
     }
   }
  else
   {
    if(set_gfx_mode(GFX_AUTODETECT,SCR_W,SCR_H,0,0)!=0)
     {
      allegro_exit();
      printf("Error setting graphics mode (FULLSCREEN):\n -> %s\n\n", allegro_error);
      return 1;
     }
   }
  set_color_depth(8);
  buffer=create_bitmap(SCR_W,SCR_H);
  CHEAT=false; CHEAT2=false;
  ScoreBoard(1);
 }

void Board()
 {
  draw_sprite(buffer,board1.frame,0,0);
  //draw_sprite(buffer,board2.frame,0,223);
  textprintf_ex(buffer,font,68,0,txcol,bgcol,"%d",level);
  textprintf_ex(buffer,font,183,0,txcol,bgcol,"%d",hiscore);

  textprintf_ex(buffer,font,40,226,txcol,bgcol,"%d",score);
  if(MODE==1) textprintf_ex(buffer,font,158,226,txcol,bgcol,"%d",money);
  if(lives==0) textprintf_ex(buffer,font,288,226,txcol,bgcol,"%d",0);
  else textprintf_ex(buffer,font,288,226,txcol,bgcol,"%d",lives-1);
  if(NPLAYERS==2)
   {
    textprintf_ex(buffer,font,40,241,txcol,bgcol,"%d",score2);
    if(MODE==1) textprintf_ex(buffer,font,158,241,txcol,bgcol,"%d",money2);
    if(lives2==0) textprintf_ex(buffer,font,288,241,txcol,bgcol,"%d",0);
    else textprintf_ex(buffer,font,288,241,txcol,bgcol,"%d",lives2-1);
   }
 }

void ScoreBoardInit()
 {
  fd=fopen(SCORETBFILE,"r");
  if(!fd)
   {
    fd=fopen(SCORETBFILE,"w");
    if(fd)
     {
      sprintf(scoretb[0].name,"www.valarsoft.com"); scoretb[0].level=5; scoretb[0].score=5000;
      sprintf(scoretb[1].name,"www.valarsoft.com"); scoretb[1].level=4; scoretb[1].score=4000;
      sprintf(scoretb[2].name,"www.valarsoft.com"); scoretb[2].level=3; scoretb[2].score=3000;
      sprintf(scoretb[3].name,"www.valarsoft.com"); scoretb[3].level=2; scoretb[3].score=2000;
      sprintf(scoretb[4].name,"www.valarsoft.com"); scoretb[4].level=1; scoretb[4].score=1000;
      for(int i=0;i<5;i++) fwrite(&scoretb[i],sizeof(SCORETB),1,fd);
      hiscore=5000;
     }
   }
  else
   {
    for(int i=0;i<5;i++) fread(&scoretb[i],sizeof(SCORETB),1,fd);
    hiscore=scoretb[0].score;
   }
  fclose(fd);
 }

void ScoreBoardInput(int pos, int pl)
 {
  int i=0;
  char ch;
  char aux[18];

  aux[0]='\0'; aux[18]='\0';
  sprintf(aux,"");
  textprintf_ex(bg,font,26+8*i,150+12*pos,8,0,">");
  if(pl==1) textprintf_ex(bg,font,3,133,8,0,"Player 1 please enter your name!  ");
  if(pl==2) textprintf_ex(bg,font,3,133,8,0,"Player 2 please enter your name!  ");
  ToScreen(bg);
  while(!key[KEY_ENTER])
   {   	
    clear_keybuf(); ch=readkey() & 0xff;
    if(ch==8 && i>0)
    {
     i--; aux[i]='\0';
     textprintf_ex(bg,font,34+8*i,150+12*pos,8,0," ");
    }
    if(((ch>=97 && ch<=122) || (ch>=65 && ch<=90) || (ch>=48 && ch<=57)) && i<17)
     {
      textprintf_ex(bg,font,34+8*i,150+12*pos,8,0,"%c",ch);
      aux[i]=ch; i++;
     }
    ToScreen(bg);
   }
  aux[i]='\0';
  sprintf(scoretb[pos].name,"%s",aux);
 }

void ScoreBoardShow(int fl)
 {
  if(fl==1)
   {
    LoadData(0);
    ToScreen(bg);
    fade_in(pal,4);
   }
  rectfill(bg,1,130,317,210,0); rect(bg,1,130,317,210,5);
  textprintf_ex(bg,font,3,133,8,0,"Name:                Level: Score:");
  for(int i=0;i<5;i++)
   {
    textprintf_ex(bg,font,10 ,150+12*i,10,0,"%d. %s",i+1,scoretb[i].name);
    if(scoretb[i].level==26) textprintf_ex(bg,font,176,150+12*i,10,0,"end");
    else textprintf_ex(bg,font,176,150+12*i,10,0,"%d",scoretb[i].level);
    textprintf_ex(bg,font,232,150+12*i,10,0,"%d",scoretb[i].score);
   }
  ToScreen(bg);
 }

void ScoreBoardWrite()
 {
  fd=fopen(SCORETBFILE,"w");
  if(fd)
   {
    for(int i=0;i<5;i++) fwrite(&scoretb[i],sizeof(SCORETB),1,fd);
   }
  fclose(fd);
 }

bool hitTest(BITMAP *obj1,BITMAP *obj2,int x1,int y1,int x2,int y2)
 {
  int xmax1,ymax1,xmin1,ymin1;
  int xmax2,ymax2,xmin2,ymin2;
  int xx1,yy1,xx2,yy2;

  xmin1=x1; ymin1=y1; xmax1=x1+obj1->w; ymax1=y1+obj1->h;
  xmin2=x2; ymin2=y2; xmax2=x2+obj2->w; ymax2=y2+obj2->h;
  if(xmin1<xmax2 && ymin1<ymax2 && xmin2<xmax1 && ymin2<ymax1)
   {
    for(int i1=0;i1<obj1->h;i1++) for(int j1=0;j1<obj1->w;j1++)
     for(int i2=0;i2<obj2->h;i2++) for(int j2=0;j2<obj2->w;j2++)
      {
       if(obj1->line[i1][j1]!=0 && obj2->line[i2][j2]!=0)
        {
         xx1=x1+j1; yy1=y1+i1;
         xx2=x2+j2; yy2=y2+i2;
         if(xx1==xx2 && yy1==yy2) return true;
        }
      }
   }
  else return false;
  return false;
 }

void Credits()
 {
  rectfill(bg,1,220,317,248,0); rect(bg,1,220,317,248,5);
  textprintf_ex(bg,font,3,222,10,0,"www.valarsoft.com 2005");
  textprintf_ex(bg,font,3,230,10,0,"");
  textprintf_ex(bg,font,3,238,10,0,"BGS 1993 Amiga game. Written using AMOS");
  ToScreen(bg);
 }

bool hitTestFast(BITMAP *obj1,BITMAP *obj2,int x1,int y1,int x2,int y2)
 {
  int xmax1,ymax1,xmin1,ymin1;
  int xmax2,ymax2,xmin2,ymin2;
  int xx1,yy1,xx2,yy2;

  xmin1=x1; ymin1=y1; xmax1=x1+obj1->w; ymax1=y1+obj1->h;
  xmin2=x2; ymin2=y2; xmax2=x2+obj2->w; ymax2=y2+obj2->h;
  if(xmin1<xmax2 && ymin1<ymax2 && xmin2<xmax1 && ymin2<ymax1)
   {
    for(int i1=0;i1<obj1->h;i1+=3) for(int j1=0;j1<obj1->w;j1+=3)
     for(int i2=0;i2<obj2->h;i2++) for(int j2=0;j2<obj2->w;j2++)
      {
       if(obj1->line[i1][j1]!=0 && obj2->line[i2][j2]!=0)
        {
         xx1=x1+j1; yy1=y1+i1;
         xx2=x2+j2; yy2=y2+i2;
         if(xx1==xx2 && yy1==yy2) return true;
        }
      }
   }
  else return false;
  return false;
 }

void ToScreen(BITMAP *buf)
 {
  stretch_blit(buf,screen,0,0,320,256,0,0,SCR_W,SCR_H);
  //blit(buf,screen,0,0,0,0,0,0);
  //blit(buf,screen,0,0,0,0,SCR_W,SCR_H);
 }

void Exit()
 {
  fade_out(4);
  exit(0); // Liberare prima la memoria
 }

void wait(int ms)
 {
  int start,now;
  
  start=now=clock();
  while(now-start<ms) { now=clock(); }
 }

int Random(int max) // Ritorna un numero pseudocasuale da 0 a max (max compreso)
 {
  max++;
  return(rand()%max);
 }

void Sync() // Sincronizzazione
 {
  if(synss) msss=clock(); synss=false; // Timer fine livello
  if(syns)  mss=clock();  syns=false;  // Timer lento
  if(syns2) mss2=clock(); syns2=false; // Timer lento 2
  if(syn)   ms=clock();   syn=false;   // Timer normale
  if(synf)  msf=clock();  synf=false;  // Timer veloce
  if(synff) msff=clock(); synff=false; // Timer velocissimo
  vsync();
  if(clock()-msss>3000) synss=true; else synss=false;
  if(clock()-mss >500)  syns=true;  else syns=false;
  if(clock()-mss2>1100) syns2=true; else syns2=false;
  if(clock()-ms  >150)  syn=true;   else syn=false;
  if(clock()-msf >80)   synf=true;  else synf=false;
  if(clock()-msff>5)    synff=true; else synff=false;
  if(key[KEY_P]) while(!key[KEY_R]) {} // Pause
 }
